"{ Package: 'stx:goodies/sunit' }"

Object subclass:#TestSuitesScripter
	instanceVariableNames:'script stream'
	classVariableNames:''
	poolDictionaries:''
	category:'SUnit-Base'
!


!TestSuitesScripter class methodsFor:'Example'!

exampleScripting
	^(TestSuitesScripter script: ' "scratch suite 3" ExampleSetTest SUnitTest* ') value

    "Modified: / 21.6.2000 / 10:18:08 / Sames"
! !

!TestSuitesScripter class methodsFor:'Init / Release'!

run: aString
	^self new run: aString
!

script: aString
	^self new setScript: aString
! !

!TestSuitesScripter methodsFor:'Printing'!

printOn: aStream
	aStream nextPutAll: (script isNil 
		ifFalse: [script] 
		ifTrue: ['N/A'])

    "Created: / 21.6.2000 / 10:15:29 / Sames"
! !

!TestSuitesScripter methodsFor:'Private'!

executeSingleSuiteScript: aString 
	| useHierachy realName testCase |
	aString last = $*
		ifTrue: 
			[realName := aString copyFrom: 1 to: aString size - 1.
			useHierachy := true]
		ifFalse: 
			[realName := aString.
			useHierachy := false].
	realName isEmpty ifTrue: [^nil].
	testCase := SUnitNameResolver classNamed: realName sunitAsSymbol.
	testCase isNil ifTrue: [^nil].
	^useHierachy
		ifTrue: [self hierachyOfTestSuitesFrom: testCase]
		ifFalse: [testCase suite]

    "Modified: / 21.6.2000 / 10:16:02 / Sames"
!

getNextToken
	[stream atEnd not and: [stream peek first = $"]] whileTrue: [self skipComment].
	^stream atEnd not
		ifTrue: [stream next]
		ifFalse: [nil]

    "Modified: / 21.6.2000 / 10:16:16 / Sames"
!

hierachyOfTestSuitesFrom: aTestCase 
	| subSuite |
	subSuite := TestSuite new.
	subSuite addTest: aTestCase suite.
	aTestCase allSubclasses do: [:each | subSuite addTest: each sunitName sunitAsSymbol sunitAsClass suite].
	^subSuite

    "Modified: / 21.6.2000 / 10:16:29 / Sames"
!

setScript: aString
	script := aString
!

skipComment
	| token inComment |
	token := stream next.
	token size > 1 & (token last = $") ifTrue: [^nil].
	inComment := true.
	[inComment & stream atEnd not]
		whileTrue: 
			[token := stream next.
			token last = $" ifTrue: [inComment := false]]

    "Modified: / 21.6.2000 / 10:16:47 / Sames"
! !

!TestSuitesScripter methodsFor:'Scripting'!

run: aString
	| suite subSuite token |
	suite := TestSuite new.
	stream := ReadStream on: aString sunitSubStrings. 
	[stream atEnd] whileFalse: 
		[token := self getNextToken.
		token notNil ifTrue: [
			subSuite := self executeSingleSuiteScript: token.
			subSuite notNil ifTrue:[suite addTest: subSuite]]].
	^suite

    "Modified: / 21.6.2000 / 10:17:11 / Sames"
!

value
	^self run: script
! !

!TestSuitesScripter class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/sunit/TestSuitesScripter.st,v 1.3 2000-12-10 13:21:05 cg Exp $'
! !
